//Testproggramm TcpIP Socket
unit Unit1;
{$mode objfpc}{$H+}
interface
uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, blcksock;
type
  { TForm1 }
  TForm1 = class(TForm)
    Btn_CTx: TButton;
    Btn_CRx: TButton;
    Btn_STx: TButton;
    Btn_SRx: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    procedure Btn_CRxClick(Sender: TObject);
    procedure Btn_CTxClick(Sender: TObject);
    procedure Btn_SRxClick(Sender: TObject);
    procedure Btn_STxClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;
  sockS : TTCPBlockSocket;//Server Socket
  sockC : TTCPBlockSocket;//Client Socket
implementation
{$R *.lfm}
{ TForm1 }
//Initialisierungen
procedure TForm1.FormShow(Sender: TObject);
begin
  sockS:= TTCPBlockSocket.Create;
  sockC:= TTCPBlockSocket.Create;
  //Server Socket
  socks.Bind('127.0.0.1','10001');
  if sockS.LastError <> 0 then
  begin
    ShowMessage('Server Fehler');
    Form1.Close;
  end
  else
  begin
    sockS.Listen;
  end;
  //Client Socket
  sockC.Connect('127.0.0.1','10001');
  if sockC.LastError = 0 then
  begin
    sockC.ConvertLineEnd:= true;
  end
  else
  begin
    ShowMessage('Keine Verbindung !');
    Form1.Close;
  end;
  Memo1.Clear;
  Memo2.Clear;
end;

//Beenden
procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  sockC.Free;
  sockS.Free;
end;

//Server =======================================================================
//Senden
procedure TForm1.Btn_STxClick(Sender: TObject);
begin
  sockS.SendString(Edit2.Text + Chr($13));
end;

//Empfang
procedure TForm1.Btn_SRxClick(Sender: TObject);
begin
  Memo2.Append(sockS.RecvPacket(50));
end;

//Client =======================================================================
//Senden
procedure TForm1.Btn_CTxClick(Sender: TObject);
begin
  sockC.SendString(Edit1.Text + Chr($13));
end;

//Empfang
procedure TForm1.Btn_CRxClick(Sender: TObject);
begin
  Memo1.Append(sockC.RecvPacket(50));
end;

end.

